package java.util.zip;

public class Inflater {
   private int strm;
   private byte[] buf;
   private int off;
   private int len;
   private boolean finished;
   private boolean needsDictionary;

   public Inflater(boolean var1) {
      this.buf = new byte[0];
      this.init(var1);
   }

   public Inflater() {
      this(false);
   }

   public synchronized void setInput(byte[] var1, int var2, int var3) {
      if (var1 == null) {
         throw new NullPointerException();
      } else if (var2 >= 0 && var3 >= 0 && var2 + var3 <= var1.length) {
         this.buf = var1;
         this.off = var2;
         this.len = var3;
      } else {
         throw new ArrayIndexOutOfBoundsException();
      }
   }

   public void setInput(byte[] var1) {
      this.setInput(var1, 0, var1.length);
   }

   public synchronized native void setDictionary(byte[] var1, int var2, int var3);

   public void setDictionary(byte[] var1) {
      this.setDictionary(var1, 0, var1.length);
   }

   public synchronized int getRemaining() {
      return this.len;
   }

   public synchronized boolean needsInput() {
      return this.len <= 0;
   }

   public synchronized boolean needsDictionary() {
      return this.needsDictionary;
   }

   public synchronized boolean finished() {
      return this.finished;
   }

   public synchronized native int inflate(byte[] var1, int var2, int var3) throws DataFormatException;

   public int inflate(byte[] var1) throws DataFormatException {
      return this.inflate(var1, 0, var1.length);
   }

   public synchronized native int getAdler();

   public synchronized native int getTotalIn();

   public synchronized native int getTotalOut();

   public synchronized native void reset();

   public synchronized native void end();

   protected void finalize() {
      this.end();
   }

   private native void init(boolean var1);
}
